<?php

include_once("inc/getwebobject.class.php");
include_once("inc/article.class.php");

class Import
{
  var $text = null;
  var $urls = null;

  function Import()
  {
    $this->text = array();
    $this->urls = array();
  }
  
  function fetch($fetch_new=false)
  {
    if(empty($_SESSION['list']) || $fetch_new == true)
    {
      if(!$this->__getArticleList())
      { 
        $_SESSION['list'] = $this->urls;
        array_push($this->text, "Fetching new topic list from host ...");
      }
    }
    else
    {
      array_push($this->text, "Using topic list from cache ...");
    }
    $this->__saveArticles();
    return($this->text);
  }
  
  function __getArticleList()
  {
    /* method to override */
    return(array());
  }
  
  
  function __saveArticles()
  {
    global $conf, $db, $html_meta;
    
    //$this->log("saveArticles: start");
    $fetched_max       = $conf->getImportMax();
    $fetched_counter   = 0;
    $processed_counter = 0;
    
    while($fetched_counter < $fetched_max && count($_SESSION['list']) > 0)
    {
      $path = array_pop($_SESSION['list']);
      //$this->log("saveArticles: fetch article $path");
      $article = new Article($path);
      $article->setDbHandle($db);

      $errno = $article->save();
      
      if($article->isBandwithUsed())
      { $fetched_counter++;}
      $processed_counter++;
      
      if($errno)
      { $msg = "<font color=\"#FFA500\">".$article->getShortErrDesc($errno)."</font>";}
      else
      { $msg = "stored";}
      
      //$this->log("saveArticles: fetch result: $errno");
      //$this->log("saveArticles: fetch article done");
      array_push($this->text, array("<a href=\"?p=article&q=".$path."\">".$path."</a>", $msg));
    }
    
    if(count($_SESSION['list']) > 0)
    { $html_meta = "<meta http-equiv=\"refresh\" content=\"2; URL=./?p=import\">\n";}
    
    array_push($this->text, "&nbsp;");
    array_push($this->text, "Articles processed: ".$processed_counter);
    array_push($this->text, "Articles fetched: ".$fetched_counter);
    array_push($this->text, "Articles left: ".count($_SESSION['list']));
  }
  
  function log($str)
  {
    $time = strftime("%H:%M:%S");
    $fp = fopen("log.txt", "a");
    if($fp)
    {
      fputs($fp, "[${time}] ".$str."\n");
    }
    fclose($fp);
  }
}

?>